#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>

static Display *d;
static Window  w;
static GC      gc;
static XSetWindowAttributes  att;
  
int screen(a,b,c,f)
int a,b,c,f;
{
  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow (d,0),
                20, 20, 640+b, 400+c, 2, 0, 1);
  att.backing_store = Always;
  XChangeWindowAttributes(d, w, CWBackingStore, &att);
/*  XChangeWindowAttributes(d,w,CWOverrideRedirect, &att); */
  XMapWindow(d,w);

  gc = XCreateGC(d,w,0,0);
/*  XFlush(d); */
}

unsigned long  setcolor(col)
unsigned char  col;
{ 
  Colormap cmap;
  XColor  c1;
  unsigned char  bit,a;
  
  bit=1;
  if((a=col & bit)==1)  c1.blue=65535L;
  else                  c1.blue=0L;
  bit<<=1;
  if((a=col & bit)==2)  c1.red=65535L;
  else                  c1.red=0L;
  bit<<=1;
  if((a=col & bit)==4)  c1.green=65535L;
  else                  c1.green=0L;
       
  cmap=DefaultColormap(d,0);
  XAllocColor(d,cmap,&c1);
  return(c1.pixel);
}

static unsigned int linestyle1=0;

int line(x1,y1,x2,y2,col,atr1,atr2,linestyle)
int  x1,y1,x2,y2,atr1,atr2;
unsigned int  col;
unsigned int  linestyle;
{
  int  i,j,k,dx,dy,x0,y0;
  unsigned int  bit;
  static unsigned char  dash[16],bit1,bit2;
  unsigned long  color;

  if(atr2==0 || (atr2==1 && linestyle == 0xffff))
    XSetLineAttributes(d,gc,1,LineSolid,CapButt,JoinMiter);
  else if(linestyle1!=linestyle){
    for(i=0;i<16;i++) dash[i]=0;
    bit=1; k=1; 
    for(j=0,i=15; j<16 && i>=0; j++){
      bit1=(unsigned char)(linestyle & bit);
      if(j!=0 && bit1!=bit2){
        k++;
        i--;
      }
      dash[i]++;
      linestyle>>=1;
      bit2=bit1; 
    }
    XSetLineAttributes(d,gc,1,LineOnOffDash,CapButt,JoinMiter);
    XSetDashes(d,gc,0,&dash[16-k],k); linestyle1=linestyle;
  }

  color=setcolor(col);
  XSetForeground(d,gc,0);  

  if(atr1==0)
    XDrawLine(d,w,gc,x1,y1,x2,y2);
  else{
    if(x1>x2) { dx=x1-x2; x0=x2; }
    else      { dx=x2-x1; x0=x1; }
    if(y1>y2) { dy=y1-y2; y0=y2; }
    else      { dy=y2-y1; y0=y1; }
    XDrawRectangle(d,w,gc,x0,y0,dx,dy);
  }
 /* XFlush(d); */
}

int pset(x,y,col)
int  x,y;
unsigned char  col;
{
  unsigned long  color;

  color=setcolor(col);
  XSetForeground(d,gc,0);  
 
  XDrawPoint(d,w,gc,x,y);
 /* XFlush(d); */
}

int circle(x,y,rx,ry,col,atr)
int  x,y,rx,ry;
unsigned char  col,atr;
{
  unsigned char  color;
  int  x0,y0;

  XSetLineAttributes(d,gc,2,LineSolid,CapButt,JoinMiter);                   color=setcolor(col);
  XSetForeground(d,gc,0);  

  x0=x-rx; y0=y-ry;
  if(atr==0)
    XDrawArc(d,w,gc,x0,y0,rx,ry,0,360*64);
  else
    XFillArc(d,w,gc,x0,y0,rx,ry,0,360*64);
 /* XFlush(d); */
}

int cls(a)
int a;
{
  XClearWindow(d,w);
 /* XFlush(d); */
} 

int normalmoji(x,y,moji,col,mode,muki)
int  x,y,col,mode,muki;
char moji[];
{
  Font    f;
  unsigned long  color;
  unsigned int  len;

  f = XLoadFont(d,"fg-16");
  color=setcolor(col);
  XSetFont(d,gc,f);
  XSetForeground(d,gc,0);
  len=strlen(moji);

  XDrawString(d,w,gc,x,y+16,moji,len);
/*  XFlush(d); */
}

int smallmoji(x,y,moji,col,mode,muki)
int  x,y,col,mode,muki;
char moji[];
{
  Font    f;
  unsigned long  color;
  unsigned int  len;

  f = XLoadFont(d,"fixed");
  color=setcolor(col);
  XSetFont(d,gc,f);
  XSetForeground(d,gc,0);
  len=strlen(moji);

  XDrawString(d,w,gc,x,y+16,moji,len);
 /* XFlush(d); */
}

int flush()
{
  XFlush(d);
}

