/*                                                        */
/*       subroutin for dcf2.c <set_dcf2.c>  ver. 2.0      */
/*                                                        */
/*                 92.9.30   by  C.Otani                  */
/*                                                        */
int set_dcf2(DCF dcf[MAX], unsigned long *n_dcf){


  int              k, k1, k2;
  unsigned long    kl, nl, nbin;
  char             fname[30], str[10];
  float            t_i, t_f, t_d;
  float            tim, data;
  float            nf;
  FILE             *fp;

  
/*   parameter input   */
  printf("\nInput UDCF file > ");   gets(fname);
  printf("\nStart time (day) > "); gets(str); t_i = atof(str);
  printf("End  time (day) > ");    gets(str); t_f = atof(str);
  printf("Interval  (day) > ");    gets(str); t_d = atof(str);


/*   parameter set   */
  nbin = (unsigned long)( (t_f - t_i) / t_d );
  t_d = (t_f - t_i)/(float)nbin;
  if ( nbin >= MAX ){
    printf("\nThe number of bin is too many !!\n");
    return(-1);
  }


/*   read data and calculate DCF   */
  if ( ( fp = fopen(fname, "r") ) == NULL ){
    printf("\nFile open error !!\n");
    exit(-1);
  }

  while( fscanf(fp,"%f%f",&tim,&data) != EOF ){
    if ( tim < t_f && tim >= t_i ){
      nl = (unsigned long)( ( tim - t_i ) / t_d );
      (dcf[nl].tim) += tim;
      (dcf[nl].dat) += data;
      (dcf[nl].err) += data*data;
      (dcf[nl].num) ++;
    }
  }
  fclose(fp);

  for ( kl=0UL, (*n_dcf)=0UL; kl<nbin; kl++){
    if ( ( nf = (float)(dcf[kl].num) ) == 1.0 ){
      dcf[kl].err = 0.0;
    }
    else if ( nf != 0.0 ){
      (dcf[kl].tim) /= nf;
      (dcf[kl].dat) /= nf;
      (dcf[kl].err) = (float)
	( sqrt(dcf[kl].err-(double)(dcf[kl].num)*pow(dcf[kl].dat,2.0) )
	 / (double)(nf-1.0) );
      (*n_dcf)++;
    }
  }


  return(0);


}

